size_x = 100.0;
size_y =  60.0;

bar_x = 15.0;
bar_y = size_y;
bar_z = bar_x;

num_bars = ceil(size_x / 2 / bar_x);

difference() {
    union() {
        for (i = [0 : num_bars - 1]) {
            f = i / (num_bars - 1);

            translate([f * (size_x - bar_x), 0.0, 0.0])
            cube([bar_x, bar_y, bar_z]);
        }

        translate([0.0, 0.0, bar_z / 2])
        cube([size_x, bar_x, bar_z / 2]);

        translate([0.0, size_y - bar_x, bar_z / 2])
        cube([size_x, bar_x, bar_z / 2]);
    }

    rim = 0.5;

    surface_x = size_x - rim * 2;
    surface_y = size_y - rim * 2;
    surface_z = bar_z * 1.0;

    translate([size_x / 2, size_y / 2, bar_z])
    intersection() {
        resize([surface_x, surface_y, surface_z])
        rotate([0, 90, 0])
        cylinder(d = 1.0, h = 1.0, center = true, $fn = 360);

        resize([surface_x, surface_y, surface_z])
        rotate([90, 0, 0])
        cylinder(d = 1.0, h = 1.0, center = true, $fn = 360);
    }

    signature();
}

module signature() {
    lines = [
        "Soap Dish",
        "Designed by Hanno Braun",
    ];

    size   = 3;
    margin = size / 2;

    linear_extrude(1)
    translate([margin, size_y - margin, 0])
    rotate([0, 0, 90])
    mirror([1, 0, 0])
    union() {
        for (i = [0 : len(lines) - 1]) {
            translate([0, -i * size * 1.5, 0])
            text(
                lines[i],
                size = size,
                font = "osifont",
                halign = "left",
                valign = "top"
            );
        }
    }
}
